//============================================================================
// camdisplay.cpp
//============================================================================

#include <GL/glut.h>
#include "camera.hpp"

//----------------------------------------------------------------------------
// OPENGL CAMERA FRUSTUM DRAWING ROUTINES
//----------------------------------------------------------------------------
void Camera::Display()
{
  // CALC EIGHT CORNERS OF FRUSTUM (NEAR PTS AND FAR PTS)
  Vec3f V[8];
  CalcVerts(V);

  glPushAttrib(GL_LIGHTING_BIT);
  glDisable(GL_LIGHTING);
  glPushAttrib(GL_LINE_BIT);
  glLineWidth(1.0);
  glColor3f(0,1,0);

  // DRAW THE FRUSTUM IN WIREFRAME
  glBegin(GL_LINE_LOOP);  // TOP FACE
    glVertex3fv(&(V[4].x)); glVertex3fv(&(V[5].x)); 
    glVertex3fv(&(V[1].x)); glVertex3fv(&(V[0].x));
  glEnd();
  glBegin(GL_LINE_LOOP);  // BOTTOM FACE
    glVertex3fv(&(V[3].x)); glVertex3fv(&(V[2].x));
    glVertex3fv(&(V[6].x)); glVertex3fv(&(V[7].x)); 
  glEnd();
  glBegin(GL_LINE_LOOP);  // LEFT FACE
    glVertex3fv(&(V[1].x)); glVertex3fv(&(V[5].x));
    glVertex3fv(&(V[6].x)); glVertex3fv(&(V[2].x)); 
  glEnd();
  glBegin(GL_LINE_LOOP);  // RIGHT FACE
    glVertex3fv(&(V[0].x)); glVertex3fv(&(V[3].x));
    glVertex3fv(&(V[7].x)); glVertex3fv(&(V[4].x)); 
  glEnd();
  glBegin(GL_LINE_LOOP);  // NEAR FACE
    glVertex3fv(&(V[1].x)); glVertex3fv(&(V[2].x));
    glVertex3fv(&(V[3].x)); glVertex3fv(&(V[0].x)); 
  glEnd();
  glBegin(GL_LINE_LOOP);  // FAR FACE
    glVertex3fv(&(V[4].x)); glVertex3fv(&(V[7].x));
    glVertex3fv(&(V[6].x)); glVertex3fv(&(V[5].x)); 
  glEnd();

  // DRAW PROJECTOR LINES FROM EYE TO CORNERS OF VIEWPLANE WINDOW
  glBegin(GL_LINES);
    glVertex3fv(&(Orig.x)); glVertex3fv(&(V[1].x));
    glVertex3fv(&(Orig.x)); glVertex3fv(&(V[2].x));
    glVertex3fv(&(Orig.x)); glVertex3fv(&(V[3].x));
    glVertex3fv(&(Orig.x)); glVertex3fv(&(V[0].x));
  glEnd();

  glPopAttrib();
  glPopAttrib();
}
