//----------------------------------------------------------------------------
// William Baxter III's Ray Tracer
//
//     Project for Comp 238, Raster Graphics
//     University of North Carolina at Chapel Hill
//     
// $Id:$
//----------------------------------------------------------------------------

#ifndef WB3CASTINGSHADER_H
#define WB3CASTINGSHADER_H

//----------------------------------------------------------------------------

#include "wb3Shader.hpp"
#include "wb3Artifact.hpp"
#include "wb3Scene.hpp"

// The Casting shader does no recursive raytracing, just casts primaries.


class wb3CastingShader : public wb3Shader
{
public:

  wb3CastingShader();
  ~wb3CastingShader();

  virtual void Shade(const wb3Scene* scene,
                     const wb3Artifact* from,
                     const wb3Artifact* hit,
                     const Ray3f& r, const Vec3f &isect,
                     Vec3f& color, Vec3f& attenuation, int hits) const;

protected:

};

//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
#endif
