//----------------------------------------------------------------------------
// William Baxter III's Ray Tracer
//
//     Project for Comp 238, Raster Graphics
//     University of North Carolina at Chapel Hill
//     
// $Id:$
//----------------------------------------------------------------------------

#ifndef WB3RAYTRACER_H
#define WB3RAYTRACER_H

#include <ppmgl2d.hpp>

class wb3Scene;

//----------------------------------------------------------------------------

class wb3RayTracer
{
public:

  wb3RayTracer(int screenWidth, int screenHeight);
  ~wb3RayTracer();

  void Trace(const wb3Scene *scene);
  void WritePPM(const char *filename);
  
protected:
  ppmGL2d m_image;
  int m_iXRes;
  int m_iYRes;
};

//----------------------------------------------------------------------------
inline void wb3RayTracer::WritePPM(const char *filename)
{
  m_image.MakePPM(filename);
}

//----------------------------------------------------------------------------
#endif
