//============================================================================
// camutils.hpp : a set of camera utility functions
//============================================================================

#include "camera.hpp"

int CamTriOverlap(Vec3f V[8], float P[][4], Vec3f A, Vec3f B, Vec3f C);
int CamTriOverlap(Camera *Cam, Vec3f A, Vec3f B, Vec3f C);

int CamQuadOverlap(Camera *Cam, Vec3f A, Vec3f B, Vec3f C, Vec3f D);
int CamQuadOverlap(Camera *Cam, float A[3], float B[3], float C[3], float D[3]);

void CalcCamPlanes(Vec3f V[8], float P[][4]);
void CalcCamPlanes(Camera *Cam, float P[][4]);

int CamMinMaxBoxOverlap(Camera *Cam, Vec3f cV[8], float cP[][4], Vec3f m, Vec3f M);
int CamMinMaxBoxOverlap(Camera *Cam, float m[3], float M[3]);

int CamCamOverlap(Vec3f V1[8], float P1[][4], Vec3f V2[8], float P2[][4]);
int CamCamOverlap(Camera *Cam1, Camera *Cam2);

void CamReflectAboutPlane(Camera *Cam, float Plane[4]);
