#include "wb3Material.hpp"

//----------------------------------------------------------------------------
wb3Material::wb3Material(float SpecExp, float IndexOfRefraction)
{
  m_fSpecExp = SpecExp;
  m_fIndex = IndexOfRefraction;
}
//----------------------------------------------------------------------------
wb3Material::wb3Material(const Vec3f& KAmbient,
                         const Vec3f& KDiffuse, 
                         const Vec3f& KSpecular, 
                         const Vec3f& KReflect, 
                         const Vec3f& KRefract,
                         float SpecExp,
                         float IndexOfRefraction)
{
  m_KAmbient = KAmbient;
  m_KDiffuse = KDiffuse;
  m_KSpecular = KSpecular;
  m_KReflect = KReflect;
  m_KRefract = KRefract;
  m_fSpecExp = SpecExp;
  m_fIndex = IndexOfRefraction;
}
//----------------------------------------------------------------------------
wb3Material::wb3Material(const Vec3f& K, float SpecExp, float IOfR)
{
  m_KAmbient = K;
  m_KDiffuse = K;
  m_KSpecular = K;
  m_KReflect = K;
  m_KRefract = K;
  m_fSpecExp = SpecExp;
  m_fIndex = IOfR;
}
