//----------------------------------------------------------------------------
// William Baxter III's Ray Tracer
//
//     Project for Comp 238, Raster Graphics
//     University of North Carolina at Chapel Hill
//     
// $Id:$
//----------------------------------------------------------------------------

#ifndef WB3RAYHIT_H
#define WB3RAYHIT_H

#include <vec3f.hpp>
#include "ray3f.hpp"

class wb3Scene;
class wb3Artifact;

//----------------------------------------------------------------------------

class wb3RayHit
{
public:

  wb3RayHit() {};
  ~wb3RayHit() {};

  
protected:
  const wb3Scene* scene;
  const wb3Artifact *from;   // the object from inside of which the  
                             // ray was cast (scene if from air)
  const wb3Artifact *hitObj; // the thing the ray hit first
  const Ray3f& I;            // the ray that intersected hitObj
  const Vec3f& hitPt;        // intersection location in 3-space
  
};

//----------------------------------------------------------------------------
#endif
